(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define('lithiumjs/common', ['exports'], factory) :
    (global = global || self, factory((global.lithiumjs = global.lithiumjs || {}, global.lithiumjs.common = {})));
}(this, function (exports) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} tagName
     * @param {?} elementClass
     * @return {?}
     */
    function registerElementSafely(tagName, elementClass) {
        /** @type {?} */
        var elementExists = !!customElements.get(tagName);
        if (elementExists) {
            console.warn(elementExists + " has already been registered");
        }
        else {
            customElements.define(tagName, elementClass);
        }
    }

    exports.registerElementSafely = registerElementSafely;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lithiumjs-common.umd.js.map
