(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('lit-element'), require('lithiumjs/common')) :
    typeof define === 'function' && define.amd ? define('lithiumjs/dropdown', ['exports', 'lit-element', 'lithiumjs/common'], factory) :
    (global = global || self, factory((global.lithiumjs = global.lithiumjs || {}, global.lithiumjs.dropdown = {}), global.litElement, global.lithiumjs.common));
}(this, function (exports, litElement, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var styles = litElement.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  .dropdown div {\n    border: 1px solid #ccc;\n    padding: 12px;\n  }\n"], ["\n  .dropdown div {\n    border: 1px solid #ccc;\n    padding: 12px;\n  }\n"])));
    var templateObject_1;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var XDropdown = /** @class */ (function (_super) {
        __extends(XDropdown, _super);
        function XDropdown() {
            var _this = _super.call(this) || this;
            _this.visible = false;
            _this.title = 'dropdown';
            _this.visible = false;
            _this.title = 'dropdown';
            return _this;
        }
        Object.defineProperty(XDropdown, "styles", {
            get: /**
             * @return {?}
             */
            function () { return styles; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        XDropdown.prototype.render = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return litElement.html(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      <div class=\"dropdown\">\n        <button @click=\"", "\" class=\"btn\">", "</button>\n        ", "\n      </div>\n    "], ["\n      <div class=\"dropdown\">\n        <button @click=\"", "\" class=\"btn\">", "</button>\n        ",
                "\n      </div>\n    "])), (/**
             * @return {?}
             */
            function () { return _this.toggle(); }), this.title, this.visible ? litElement.html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n            <div>\n              <slot></slot>\n            </div>"], ["\n            <div>\n              <slot></slot>\n            </div>"]))) : '');
        };
        /**
         * @return {?}
         */
        XDropdown.prototype.toggle = /**
         * @return {?}
         */
        function () {
            this.visible = !this.visible;
            this.dispatchEvent(new CustomEvent('visibleChange', { detail: this.visible }));
        };
        __decorate([
            litElement.property(),
            __metadata("design:type", Object)
        ], XDropdown.prototype, "visible", void 0);
        __decorate([
            litElement.property(),
            __metadata("design:type", Object)
        ], XDropdown.prototype, "title", void 0);
        return XDropdown;
    }(litElement.LitElement));
    common.registerElementSafely('x-dropdown', XDropdown);
    var templateObject_1$1, templateObject_2;

    exports.XDropdown = XDropdown;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lithiumjs-dropdown.umd.js.map
