(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('lit-element'), require('lithiumjs/common')) :
    typeof define === 'function' && define.amd ? define('lithiumjs/loading-spinner', ['exports', 'lit-element', 'lithiumjs/common'], factory) :
    (global = global || self, factory((global.lithiumjs = global.lithiumjs || {}, global.lithiumjs['loading-spinner'] = {}), global.litElement, global.lithiumjs.common));
}(this, function (exports, litElement, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var styles = litElement.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  :host {\n    --primary-color: #ccc;\n  }\n  .spinner {\n    animation: rotation 1.4s linear infinite;\n    stroke: #ccc;\n    will-change: transform, animation;\n  }\n  .spinner--light .spinner {\n    stroke: var(--primary-color);\n  }\n  @keyframes rotation\n  {\n    0% {\n      transform: rotate(0deg);\n    }\n    100% {\n      transform: rotate(270deg);\n    }\n  }\n  .circle {\n    stroke-dasharray: 187;\n    stroke-dashoffset: 0;\n    transform-origin: center;\n    animation: turn 1.4s ease-in-out infinite;\n  }\n  @keyframes turn\n  {\n    0% {\n      stroke-dashoffset: 187;\n    }\n    50% {\n      stroke-dashoffset: 46.75;\n      transform: rotate(135deg);\n    }\n    100% {\n      stroke-dashoffset: 187;\n      transform: rotate(450deg);\n    }\n  }\n"], ["\n  :host {\n    --primary-color: #ccc;\n  }\n  .spinner {\n    animation: rotation 1.4s linear infinite;\n    stroke: #ccc;\n    will-change: transform, animation;\n  }\n  .spinner--light .spinner {\n    stroke: var(--primary-color);\n  }\n  @keyframes rotation\n  {\n    0% {\n      transform: rotate(0deg);\n    }\n    100% {\n      transform: rotate(270deg);\n    }\n  }\n  .circle {\n    stroke-dasharray: 187;\n    stroke-dashoffset: 0;\n    transform-origin: center;\n    animation: turn 1.4s ease-in-out infinite;\n  }\n  @keyframes turn\n  {\n    0% {\n      stroke-dashoffset: 187;\n    }\n    50% {\n      stroke-dashoffset: 46.75;\n      transform: rotate(135deg);\n    }\n    100% {\n      stroke-dashoffset: 187;\n      transform: rotate(450deg);\n    }\n  }\n"])));
    var templateObject_1;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var   
    // @dynamic
    LithiumLoadingSpinner = /** @class */ (function (_super) {
        __extends(LithiumLoadingSpinner, _super);
        function LithiumLoadingSpinner() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(LithiumLoadingSpinner, "styles", {
            get: /**
             * @return {?}
             */
            function () {
                return styles;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        LithiumLoadingSpinner.prototype.render = /**
         * @return {?}
         */
        function () {
            return litElement.html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n      <div>\n        <svg class=\"spinner\" width=\"65px\" height=\"65px\" viewBox=\"0 0 66 66\" xmlns=\"http://www.w3.org/2000/svg\">\n          <circle class=\"circle\" fill=\"none\" stroke-width=\"6\" stroke-linecap=\"round\" cx=\"33\" cy=\"33\" r=\"30\"></circle>\n        </svg>\n      </div>\n    "], ["\n      <div>\n        <svg class=\"spinner\" width=\"65px\" height=\"65px\" viewBox=\"0 0 66 66\" xmlns=\"http://www.w3.org/2000/svg\">\n          <circle class=\"circle\" fill=\"none\" stroke-width=\"6\" stroke-linecap=\"round\" cx=\"33\" cy=\"33\" r=\"30\"></circle>\n        </svg>\n      </div>\n    "])));
        };
        return LithiumLoadingSpinner;
    }(litElement.LitElement));
    common.registerElementSafely('li-loading-spinner', LithiumLoadingSpinner);
    var templateObject_1$1;

    exports.LithiumLoadingSpinner = LithiumLoadingSpinner;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lithiumjs-loading-spinner.umd.js.map
