(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('lit-element'), require('@a11y/focus-trap'), require('lithiumjs/common')) :
    typeof define === 'function' && define.amd ? define('lithiumjs/modal', ['exports', 'lit-element', '@a11y/focus-trap', 'lithiumjs/common'], factory) :
    (global = global || self, factory((global.lithiumjs = global.lithiumjs || {}, global.lithiumjs.modal = {}), global.litElement, null, global.lithiumjs.common));
}(this, function (exports, litElement, focusTrap, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var styles = litElement.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  .li-modal-wrapper {\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    z-index: 300;\n  }\n\n  .li-modal {\n    border: 1px solid #ccc;\n    padding: 12px;\n    background-color: #fff;\n    color: #2d2d2d;\n    width: 500px;\n    max-width: 100%;\n    margin: 24px auto;\n    position: relative;\n    z-index: 302;\n  }\n\n  .li-modal-close-btn {\n    position: absolute;\n    text-align: center;\n    width: auto;\n    height: auto;\n    padding: 12px;\n    font-size: 24px;\n    top: 0;\n    right: 0;\n    line-height: 14px;\n    border: 0;\n    background: transparent;\n    cursor: pointer;\n  }\n\n  .li-modal-backdrop {\n    background-color: rgba(0, 0, 0, 0.5);\n    position: fixed;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    z-index: 301;\n  }\n"], ["\n  .li-modal-wrapper {\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    z-index: 300;\n  }\n\n  .li-modal {\n    border: 1px solid #ccc;\n    padding: 12px;\n    background-color: #fff;\n    color: #2d2d2d;\n    width: 500px;\n    max-width: 100%;\n    margin: 24px auto;\n    position: relative;\n    z-index: 302;\n  }\n\n  .li-modal-close-btn {\n    position: absolute;\n    text-align: center;\n    width: auto;\n    height: auto;\n    padding: 12px;\n    font-size: 24px;\n    top: 0;\n    right: 0;\n    line-height: 14px;\n    border: 0;\n    background: transparent;\n    cursor: pointer;\n  }\n\n  .li-modal-backdrop {\n    background-color: rgba(0, 0, 0, 0.5);\n    position: fixed;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    z-index: 301;\n  }\n"])));
    var templateObject_1;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var LithiumModal = /** @class */ (function (_super) {
        __extends(LithiumModal, _super);
        function LithiumModal() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.open = false;
            _this.backdropClosable = true;
            return _this;
        }
        Object.defineProperty(LithiumModal, "styles", {
            get: /**
             * @return {?}
             */
            function () {
                return styles;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        LithiumModal.prototype.render = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return litElement.html(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      ", "\n    "], ["\n      ",
                "\n    "])), this.open
                ? litElement.html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n          <div class=\"li-modal-wrapper\">\n            <div class=\"li-modal\" role=\"dialog\">\n              <focus-trap>\n                <div class=\"li-modal-header\">\n                  <slot name=\"header\"></slot>\n                  <button @click=\"", "\" type=\"button\" aria-label=\"closed\" class=\"li-modal-close-btn\">&times;</button>\n                </div>\n                <div class=\"li-modal-content\">\n                  <slot></slot>\n                </div>\n                <div class=\"li-modal-footer\">\n                  <slot name=\"footer\"></slot>\n                </div>\n              </focus-trap>\n            </div>\n            <div @click=\"", "\" class=\"li-modal-backdrop\"></div>\n          </div>\n          "], ["\n          <div class=\"li-modal-wrapper\">\n            <div class=\"li-modal\" role=\"dialog\">\n              <focus-trap>\n                <div class=\"li-modal-header\">\n                  <slot name=\"header\"></slot>\n                  <button @click=\"", "\" type=\"button\" aria-label=\"closed\" class=\"li-modal-close-btn\">&times;</button>\n                </div>\n                <div class=\"li-modal-content\">\n                  <slot></slot>\n                </div>\n                <div class=\"li-modal-footer\">\n                  <slot name=\"footer\"></slot>\n                </div>\n              </focus-trap>\n            </div>\n            <div @click=\"", "\" class=\"li-modal-backdrop\"></div>\n          </div>\n          "])), (/**
                 * @return {?}
                 */
                function () { return _this.close(); }), (/**
                 * @return {?}
                 */
                function () { return _this.backdropClose(); })) : '');
        };
        /**
         * @param {?} changedProperties
         * @return {?}
         */
        LithiumModal.prototype.updated = /**
         * @param {?} changedProperties
         * @return {?}
         */
        function (changedProperties) {
            if (this.open && this.open !== changedProperties.get('open')) ;
        };
        /**
         * @return {?}
         */
        LithiumModal.prototype.close = /**
         * @return {?}
         */
        function () {
            this.open = !this.open;
            this.dispatchEvent(new CustomEvent('openChange', { detail: this.open }));
        };
        /**
         * @return {?}
         */
        LithiumModal.prototype.backdropClose = /**
         * @return {?}
         */
        function () {
            if (this.backdropClosable) {
                this.close();
            }
        };
        __decorate([
            litElement.property({ type: Boolean }),
            __metadata("design:type", Object)
        ], LithiumModal.prototype, "open", void 0);
        __decorate([
            litElement.property({ type: Boolean }),
            __metadata("design:type", Object)
        ], LithiumModal.prototype, "backdropClosable", void 0);
        return LithiumModal;
    }(litElement.LitElement));
    common.registerElementSafely('li-modal', LithiumModal);
    var templateObject_1$1, templateObject_2;

    exports.LithiumModal = LithiumModal;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lithiumjs-modal.umd.js.map
