(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('lit-element'), require('lithiumjs/common')) :
    typeof define === 'function' && define.amd ? define('lithiumjs/side-nav', ['exports', 'lit-element', 'lithiumjs/common'], factory) :
    (global = global || self, factory((global.lithiumjs = global.lithiumjs || {}, global.lithiumjs['side-nav'] = {}), global.litElement, global.lithiumjs.common));
}(this, function (exports, litElement, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var styles = litElement.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  :host {\n    --header-background-color: #f2f2f2;\n    --header-text-color: #2d2d2d;\n    --nav-top: 0;\n    --nav-border-color: #f2f2f2;\n    --nav-background-color: #fff;\n    --nav-text-color: #2d2d2d;\n    --nav-width: 280px;\n    --transition-speed: 250ms;\n  }\n\n  .li-side-nav {\n    position: fixed;\n    left: -400px;\n    top: var(--nav-top);\n    bottom: 0;\n    width: 80%;\n    max-width: var(--nav-width);\n    z-index: 201;\n    background-color: var(--nav-background-color);\n    overflow: hidden;\n    will-change: left;\n    transition: left var(--transition-speed) ease-in;\n  }\n\n  :host([sticky]) .li-side-nav {\n    border-right: 1px solid var(--nav-border-color);\n  }\n\n  .li-side-nav-open .li-side-nav {\n    left: 0;\n  }\n\n  .li-menu-heading {\n    font-size: 18px;\n    position: relative;\n    height: 50px;\n    overflow: hidden;\n    background-color: var(--header-background-color);\n    color: var(--header-text-color);\n  }\n\n  .li-menu-heading-text {\n    float: left;\n    padding: 14px 16px;\n  }\n\n  .li-menu-close-btn {\n    border: 0;\n    margin-bottom: 6px;\n    padding: 10px 20px;\n    height: 50px;\n    display: block;\n    position: absolute;\n    font-size: 1.5em;\n    right: 0;\n    background-color: transparent;\n    cursor: pointer;\n    color: var(--header-text-color);\n  }\n\n  .li-side-nav-slot::slotted(a), .li-side-nav-slot::slotted(button) {\n    display: block;\n    padding: 18px 13px 16px 26px;\n    font-size: 1em;\n    text-decoration: none;\n    color: var(--nav-text-color);\n    position: relative;\n    font-weight: bold;\n    cursor: pointer;\n  }\n\n  .li-side-nav-backdrop {\n    position: fixed;\n    top: 0;\n    left: 0;\n    z-index: 200;\n    width: 100%;\n    height: 100%;\n    background: transparent;\n    pointer-events: none;\n    will-change: background;\n    transition: background var(--transition-speed) ease-in;\n  }\n\n  .li-side-nav-open .li-side-nav-backdrop {\n    pointer-events: auto;\n    background: rgba(0,0,0,.5);\n  }\n"], ["\n  :host {\n    --header-background-color: #f2f2f2;\n    --header-text-color: #2d2d2d;\n    --nav-top: 0;\n    --nav-border-color: #f2f2f2;\n    --nav-background-color: #fff;\n    --nav-text-color: #2d2d2d;\n    --nav-width: 280px;\n    --transition-speed: 250ms;\n  }\n\n  .li-side-nav {\n    position: fixed;\n    left: -400px;\n    top: var(--nav-top);\n    bottom: 0;\n    width: 80%;\n    max-width: var(--nav-width);\n    z-index: 201;\n    background-color: var(--nav-background-color);\n    overflow: hidden;\n    will-change: left;\n    transition: left var(--transition-speed) ease-in;\n  }\n\n  :host([sticky]) .li-side-nav {\n    border-right: 1px solid var(--nav-border-color);\n  }\n\n  .li-side-nav-open .li-side-nav {\n    left: 0;\n  }\n\n  .li-menu-heading {\n    font-size: 18px;\n    position: relative;\n    height: 50px;\n    overflow: hidden;\n    background-color: var(--header-background-color);\n    color: var(--header-text-color);\n  }\n\n  .li-menu-heading-text {\n    float: left;\n    padding: 14px 16px;\n  }\n\n  .li-menu-close-btn {\n    border: 0;\n    margin-bottom: 6px;\n    padding: 10px 20px;\n    height: 50px;\n    display: block;\n    position: absolute;\n    font-size: 1.5em;\n    right: 0;\n    background-color: transparent;\n    cursor: pointer;\n    color: var(--header-text-color);\n  }\n\n  .li-side-nav-slot::slotted(a), .li-side-nav-slot::slotted(button) {\n    display: block;\n    padding: 18px 13px 16px 26px;\n    font-size: 1em;\n    text-decoration: none;\n    color: var(--nav-text-color);\n    position: relative;\n    font-weight: bold;\n    cursor: pointer;\n  }\n\n  .li-side-nav-backdrop {\n    position: fixed;\n    top: 0;\n    left: 0;\n    z-index: 200;\n    width: 100%;\n    height: 100%;\n    background: transparent;\n    pointer-events: none;\n    will-change: background;\n    transition: background var(--transition-speed) ease-in;\n  }\n\n  .li-side-nav-open .li-side-nav-backdrop {\n    pointer-events: auto;\n    background: rgba(0,0,0,.5);\n  }\n"])));
    var templateObject_1;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var LithiumSideNav = /** @class */ (function (_super) {
        __extends(LithiumSideNav, _super);
        function LithiumSideNav() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.open = false;
            _this.sticky = false;
            _this.closeOnInnerClick = true;
            return _this;
        }
        Object.defineProperty(LithiumSideNav, "styles", {
            get: /**
             * @return {?}
             */
            function () {
                return styles;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        LithiumSideNav.prototype.render = /**
         * @return {?}
         */
        function () {
            var _this = this;
            return litElement.html(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n      <div .classList=", ">\n        <nav class=\"li-side-nav\">\n          ", "\n          <div @click=", ">\n            <slot class=\"li-side-nav-slot\"></slot>\n          </div>\n        </nav>\n        ", "\n      </div>\n    "], ["\n      <div .classList=", ">\n        <nav class=\"li-side-nav\">\n          ",
                "\n          <div @click=", ">\n            <slot class=\"li-side-nav-slot\"></slot>\n          </div>\n        </nav>\n        ", "\n      </div>\n    "])), this.sticky || this.open ? 'li-side-nav-open' : '', !this.sticky ? litElement.html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n            <div class=\"li-menu-heading\">\n              <div class=\"li-menu-heading-text\"><slot name=\"heading\">Menu</slot></div>\n              <button aria-label=\"close menu\" @click=", " class=\"li-menu-close-btn\">&times;</button>\n            </div>\n          "], ["\n            <div class=\"li-menu-heading\">\n              <div class=\"li-menu-heading-text\"><slot name=\"heading\">Menu</slot></div>\n              <button aria-label=\"close menu\" @click=", " class=\"li-menu-close-btn\">&times;</button>\n            </div>\n          "])), (/**
             * @param {?} e
             * @return {?}
             */
            function (e) { return _this.close(); })) : '', (/**
             * @return {?}
             */
            function () { return _this.navClose(); }), !this.sticky ? litElement.html(templateObject_2 || (templateObject_2 = __makeTemplateObject(["<div @click=", " class=\"li-side-nav-backdrop\"></div>"], ["<div @click=", " class=\"li-side-nav-backdrop\"></div>"])), (/**
             * @return {?}
             */
            function () { return _this.close(); })) : '');
        };
        /**
         * @return {?}
         */
        LithiumSideNav.prototype.close = /**
         * @return {?}
         */
        function () {
            this.open = false;
            this.dispatchEvent(new CustomEvent('openChange', { detail: this.open }));
        };
        /**
         * @return {?}
         */
        LithiumSideNav.prototype.navClose = /**
         * @return {?}
         */
        function () {
            if (this.closeOnInnerClick && !this.sticky) {
                this.open = false;
                this.dispatchEvent(new CustomEvent('openChange', { detail: this.open }));
            }
        };
        __decorate([
            litElement.property({ type: Boolean }),
            __metadata("design:type", Object)
        ], LithiumSideNav.prototype, "open", void 0);
        __decorate([
            litElement.property({ type: Boolean }),
            __metadata("design:type", Object)
        ], LithiumSideNav.prototype, "sticky", void 0);
        __decorate([
            litElement.property({ type: Boolean }),
            __metadata("design:type", Object)
        ], LithiumSideNav.prototype, "closeOnInnerClick", void 0);
        return LithiumSideNav;
    }(litElement.LitElement));
    common.registerElementSafely('li-side-nav', LithiumSideNav);
    var templateObject_1$1, templateObject_2, templateObject_3;

    exports.LithiumSideNav = LithiumSideNav;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lithiumjs-side-nav.umd.js.map
