import { __makeTemplateObject, __extends, __decorate, __metadata } from 'tslib';
import { css, html, property, LitElement } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';
import { highlight, languages } from 'prismjs';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  /**\n    * prism.js default theme for JavaScript, CSS and HTML\n    * Based on dabblet (http://dabblet.com)\n    * @author Lea Verou\n    */\n\n  code[class*=\"language-\"],\n  pre[class*=\"language-\"] {\n    color: black;\n    background: none;\n    text-shadow: 0 1px white;\n    font-family: Consolas, Monaco, 'Andale Mono', 'Ubuntu Mono', monospace;\n    font-size: 1em;\n    text-align: left;\n    white-space: pre;\n    word-spacing: normal;\n    word-break: normal;\n    word-wrap: normal;\n    line-height: 1.5;\n\n    -moz-tab-size: 4;\n    -o-tab-size: 4;\n    tab-size: 4;\n\n    -webkit-hyphens: none;\n    -moz-hyphens: none;\n    -ms-hyphens: none;\n    hyphens: none;\n  }\n\n  pre[class*=\"language-\"]::-moz-selection, pre[class*=\"language-\"] ::-moz-selection,\n  code[class*=\"language-\"]::-moz-selection, code[class*=\"language-\"] ::-moz-selection {\n    text-shadow: none;\n    background: #b3d4fc;\n  }\n\n  pre[class*=\"language-\"]::selection, pre[class*=\"language-\"] ::selection,\n  code[class*=\"language-\"]::selection, code[class*=\"language-\"] ::selection {\n    text-shadow: none;\n    background: #b3d4fc;\n  }\n\n  @media print {\n    code[class*=\"language-\"],\n    pre[class*=\"language-\"] {\n      text-shadow: none;\n    }\n  }\n\n  /* Code blocks */\n  pre[class*=\"language-\"] {\n    padding: 1em;\n    margin: .5em 0;\n    overflow: auto;\n  }\n\n  :not(pre) > code[class*=\"language-\"],\n  pre[class*=\"language-\"] {\n    background: #f5f2f0;\n  }\n\n  /* Inline code */\n  :not(pre) > code[class*=\"language-\"] {\n    padding: .1em;\n    border-radius: .3em;\n    white-space: normal;\n  }\n\n  .token.comment,\n  .token.prolog,\n  .token.doctype,\n  .token.cdata {\n    color: slategray;\n  }\n\n  .token.punctuation {\n    color: #999;\n  }\n\n  .namespace {\n    opacity: .7;\n  }\n\n  .token.property,\n  .token.tag,\n  .token.boolean,\n  .token.number,\n  .token.constant,\n  .token.symbol,\n  .token.deleted {\n    color: #905;\n  }\n\n  .token.selector,\n  .token.attr-name,\n  .token.string,\n  .token.char,\n  .token.builtin,\n  .token.inserted {\n    color: #690;\n  }\n\n  .token.operator,\n  .token.entity,\n  .token.url,\n  .language-css .token.string,\n  .style .token.string {\n    color: #9a6e3a;\n    background: hsla(0, 0%, 100%, .5);\n  }\n\n  .token.atrule,\n  .token.attr-value,\n  .token.keyword {\n    color: #07a;\n  }\n\n  .token.function,\n  .token.class-name {\n    color: #DD4A68;\n  }\n\n  .token.regex,\n  .token.important,\n  .token.variable {\n    color: #e90;\n  }\n\n  .token.important,\n  .token.bold {\n    font-weight: bold;\n  }\n  .token.italic {\n    font-style: italic;\n  }\n\n  .token.entity {\n    cursor: help;\n  }\n\n  /* CUSTOM */\n  :host {\n    display: block;\n    margin-bottom: 48px;\n  }\n\n  pre {\n    padding-bottom: 0;\n  }\n\n  code {\n    display: block;\n    margin: -58px 0px -60px;\n  }\n\n  :not(pre) > code[class*='language-'],\n  pre[class*='language-'] {\n    background: #f3f3f3;\n    border-left: 8px solid #e4e4e4;\n    padding-top: 38px;\n  }\n"], ["\n  /**\n    * prism.js default theme for JavaScript, CSS and HTML\n    * Based on dabblet (http://dabblet.com)\n    * @author Lea Verou\n    */\n\n  code[class*=\"language-\"],\n  pre[class*=\"language-\"] {\n    color: black;\n    background: none;\n    text-shadow: 0 1px white;\n    font-family: Consolas, Monaco, 'Andale Mono', 'Ubuntu Mono', monospace;\n    font-size: 1em;\n    text-align: left;\n    white-space: pre;\n    word-spacing: normal;\n    word-break: normal;\n    word-wrap: normal;\n    line-height: 1.5;\n\n    -moz-tab-size: 4;\n    -o-tab-size: 4;\n    tab-size: 4;\n\n    -webkit-hyphens: none;\n    -moz-hyphens: none;\n    -ms-hyphens: none;\n    hyphens: none;\n  }\n\n  pre[class*=\"language-\"]::-moz-selection, pre[class*=\"language-\"] ::-moz-selection,\n  code[class*=\"language-\"]::-moz-selection, code[class*=\"language-\"] ::-moz-selection {\n    text-shadow: none;\n    background: #b3d4fc;\n  }\n\n  pre[class*=\"language-\"]::selection, pre[class*=\"language-\"] ::selection,\n  code[class*=\"language-\"]::selection, code[class*=\"language-\"] ::selection {\n    text-shadow: none;\n    background: #b3d4fc;\n  }\n\n  @media print {\n    code[class*=\"language-\"],\n    pre[class*=\"language-\"] {\n      text-shadow: none;\n    }\n  }\n\n  /* Code blocks */\n  pre[class*=\"language-\"] {\n    padding: 1em;\n    margin: .5em 0;\n    overflow: auto;\n  }\n\n  :not(pre) > code[class*=\"language-\"],\n  pre[class*=\"language-\"] {\n    background: #f5f2f0;\n  }\n\n  /* Inline code */\n  :not(pre) > code[class*=\"language-\"] {\n    padding: .1em;\n    border-radius: .3em;\n    white-space: normal;\n  }\n\n  .token.comment,\n  .token.prolog,\n  .token.doctype,\n  .token.cdata {\n    color: slategray;\n  }\n\n  .token.punctuation {\n    color: #999;\n  }\n\n  .namespace {\n    opacity: .7;\n  }\n\n  .token.property,\n  .token.tag,\n  .token.boolean,\n  .token.number,\n  .token.constant,\n  .token.symbol,\n  .token.deleted {\n    color: #905;\n  }\n\n  .token.selector,\n  .token.attr-name,\n  .token.string,\n  .token.char,\n  .token.builtin,\n  .token.inserted {\n    color: #690;\n  }\n\n  .token.operator,\n  .token.entity,\n  .token.url,\n  .language-css .token.string,\n  .style .token.string {\n    color: #9a6e3a;\n    background: hsla(0, 0%, 100%, .5);\n  }\n\n  .token.atrule,\n  .token.attr-value,\n  .token.keyword {\n    color: #07a;\n  }\n\n  .token.function,\n  .token.class-name {\n    color: #DD4A68;\n  }\n\n  .token.regex,\n  .token.important,\n  .token.variable {\n    color: #e90;\n  }\n\n  .token.important,\n  .token.bold {\n    font-weight: bold;\n  }\n  .token.italic {\n    font-style: italic;\n  }\n\n  .token.entity {\n    cursor: help;\n  }\n\n  /* CUSTOM */\n  :host {\n    display: block;\n    margin-bottom: 48px;\n  }\n\n  pre {\n    padding-bottom: 0;\n  }\n\n  code {\n    display: block;\n    margin: -58px 0px -60px;\n  }\n\n  :not(pre) > code[class*='language-'],\n  pre[class*='language-'] {\n    background: #f3f3f3;\n    border-left: 8px solid #e4e4e4;\n    padding-top: 38px;\n  }\n"])));
var templateObject_1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var LithiumCodeExample = /** @class */ (function (_super) {
    __extends(LithiumCodeExample, _super);
    function LithiumCodeExample() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.language = 'javascript';
        _this.code = '';
        _this.renderedCode = '';
        return _this;
    }
    Object.defineProperty(LithiumCodeExample, "styles", {
        get: /**
         * @return {?}
         */
        function () { return styles; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumCodeExample.prototype.render = /**
     * @return {?}
     */
    function () {
        return html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n      <div class=\"li-code-example\">\n        <pre .className=\"", "\">\n          <code .className=\"", "\" .innerHTML=\"", "\"></code>\n        </pre>\n      </div>\n    "], ["\n      <div class=\"li-code-example\">\n        <pre .className=\"", "\">\n          <code .className=\"", "\" .innerHTML=\"", "\"></code>\n        </pre>\n      </div>\n    "])), 'language-' + this.language, 'language-' + this.language, this.renderedCode);
    };
    /**
     * @return {?}
     */
    LithiumCodeExample.prototype.updated = /**
     * @return {?}
     */
    function () {
        this.renderedCode = highlight(this.code, languages[this.language]);
    };
    __decorate([
        property({ type: String }),
        __metadata("design:type", Object)
    ], LithiumCodeExample.prototype, "language", void 0);
    __decorate([
        property({ type: String }),
        __metadata("design:type", Object)
    ], LithiumCodeExample.prototype, "code", void 0);
    __decorate([
        property({ type: String }),
        __metadata("design:type", Object)
    ], LithiumCodeExample.prototype, "renderedCode", void 0);
    return LithiumCodeExample;
}(LitElement));
registerElementSafely('li-code-example', LithiumCodeExample);
var templateObject_1$1;

export { LithiumCodeExample };
//# sourceMappingURL=lithiumjs-code-example.js.map
