import { __makeTemplateObject, __extends, __decorate, __metadata } from 'tslib';
import { css, html, property, LitElement } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  .dropdown div {\n    border: 1px solid #ccc;\n    padding: 12px;\n  }\n"], ["\n  .dropdown div {\n    border: 1px solid #ccc;\n    padding: 12px;\n  }\n"])));
var templateObject_1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var XDropdown = /** @class */ (function (_super) {
    __extends(XDropdown, _super);
    function XDropdown() {
        var _this = _super.call(this) || this;
        _this.visible = false;
        _this.title = 'dropdown';
        _this.visible = false;
        _this.title = 'dropdown';
        return _this;
    }
    Object.defineProperty(XDropdown, "styles", {
        get: /**
         * @return {?}
         */
        function () { return styles; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    XDropdown.prototype.render = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return html(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      <div class=\"dropdown\">\n        <button @click=\"", "\" class=\"btn\">", "</button>\n        ", "\n      </div>\n    "], ["\n      <div class=\"dropdown\">\n        <button @click=\"", "\" class=\"btn\">", "</button>\n        ",
            "\n      </div>\n    "])), (/**
         * @return {?}
         */
        function () { return _this.toggle(); }), this.title, this.visible ? html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n            <div>\n              <slot></slot>\n            </div>"], ["\n            <div>\n              <slot></slot>\n            </div>"]))) : '');
    };
    /**
     * @return {?}
     */
    XDropdown.prototype.toggle = /**
     * @return {?}
     */
    function () {
        this.visible = !this.visible;
        this.dispatchEvent(new CustomEvent('visibleChange', { detail: this.visible }));
    };
    __decorate([
        property(),
        __metadata("design:type", Object)
    ], XDropdown.prototype, "visible", void 0);
    __decorate([
        property(),
        __metadata("design:type", Object)
    ], XDropdown.prototype, "title", void 0);
    return XDropdown;
}(LitElement));
registerElementSafely('x-dropdown', XDropdown);
var templateObject_1$1, templateObject_2;

export { XDropdown };
//# sourceMappingURL=lithiumjs-dropdown.js.map
