import { __makeTemplateObject, __extends } from 'tslib';
import { css, html, LitElement } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  :host {\n    --primary-color: #ccc;\n  }\n  .spinner {\n    animation: rotation 1.4s linear infinite;\n    stroke: #ccc;\n    will-change: transform, animation;\n  }\n  .spinner--light .spinner {\n    stroke: var(--primary-color);\n  }\n  @keyframes rotation\n  {\n    0% {\n      transform: rotate(0deg);\n    }\n    100% {\n      transform: rotate(270deg);\n    }\n  }\n  .circle {\n    stroke-dasharray: 187;\n    stroke-dashoffset: 0;\n    transform-origin: center;\n    animation: turn 1.4s ease-in-out infinite;\n  }\n  @keyframes turn\n  {\n    0% {\n      stroke-dashoffset: 187;\n    }\n    50% {\n      stroke-dashoffset: 46.75;\n      transform: rotate(135deg);\n    }\n    100% {\n      stroke-dashoffset: 187;\n      transform: rotate(450deg);\n    }\n  }\n"], ["\n  :host {\n    --primary-color: #ccc;\n  }\n  .spinner {\n    animation: rotation 1.4s linear infinite;\n    stroke: #ccc;\n    will-change: transform, animation;\n  }\n  .spinner--light .spinner {\n    stroke: var(--primary-color);\n  }\n  @keyframes rotation\n  {\n    0% {\n      transform: rotate(0deg);\n    }\n    100% {\n      transform: rotate(270deg);\n    }\n  }\n  .circle {\n    stroke-dasharray: 187;\n    stroke-dashoffset: 0;\n    transform-origin: center;\n    animation: turn 1.4s ease-in-out infinite;\n  }\n  @keyframes turn\n  {\n    0% {\n      stroke-dashoffset: 187;\n    }\n    50% {\n      stroke-dashoffset: 46.75;\n      transform: rotate(135deg);\n    }\n    100% {\n      stroke-dashoffset: 187;\n      transform: rotate(450deg);\n    }\n  }\n"])));
var templateObject_1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var  
// @dynamic
LithiumLoadingSpinner = /** @class */ (function (_super) {
    __extends(LithiumLoadingSpinner, _super);
    function LithiumLoadingSpinner() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(LithiumLoadingSpinner, "styles", {
        get: /**
         * @return {?}
         */
        function () {
            return styles;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumLoadingSpinner.prototype.render = /**
     * @return {?}
     */
    function () {
        return html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n      <div>\n        <svg class=\"spinner\" width=\"65px\" height=\"65px\" viewBox=\"0 0 66 66\" xmlns=\"http://www.w3.org/2000/svg\">\n          <circle class=\"circle\" fill=\"none\" stroke-width=\"6\" stroke-linecap=\"round\" cx=\"33\" cy=\"33\" r=\"30\"></circle>\n        </svg>\n      </div>\n    "], ["\n      <div>\n        <svg class=\"spinner\" width=\"65px\" height=\"65px\" viewBox=\"0 0 66 66\" xmlns=\"http://www.w3.org/2000/svg\">\n          <circle class=\"circle\" fill=\"none\" stroke-width=\"6\" stroke-linecap=\"round\" cx=\"33\" cy=\"33\" r=\"30\"></circle>\n        </svg>\n      </div>\n    "])));
    };
    return LithiumLoadingSpinner;
}(LitElement));
registerElementSafely('li-loading-spinner', LithiumLoadingSpinner);
var templateObject_1$1;

export { LithiumLoadingSpinner };
//# sourceMappingURL=lithiumjs-loading-spinner.js.map
