import { __makeTemplateObject, __extends, __decorate, __metadata } from 'tslib';
import { css, html, property, LitElement } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  :host {\n    --shadow-color: rgba(0, 0, 0, 0.1);\n    --off-white: #f5f5f5;\n    --primary-color: #2d2d2d;\n    --text-color: #ccc;\n  }\n  .lit-progress-bar {\n    width: 100%;\n    height: 20px;\n    background: var(--off-white);\n    border-radius: 2px;\n    position: relative;\n    overflow: hidden;\n    text-align: center;\n    -webkit-box-shadow: inset 0 1px 2px var(--shadow-color);\n    box-shadow: inset 0 1px 2px var(--shadow-color);\n    padding: 2px;\n    margin-bottom: 4px;\n  }\n  .lit-progress-bar__inner {\n    width: 100%;\n    height: 100%;\n    background: var(--primary-color);\n    position: absolute;\n    top: 0;\n    left: -100%;\n    text-align: center;\n    line-height: 35px;\n    font-size: 1em;\n    will-change: transform;\n    transition: transform 100ms ease-in;\n  }\n  .lit-progress-bar__value {\n    color: var(--text-color);\n    z-index: 2;\n    position: absolute;\n    text-align: center;\n    left: 0;\n    right: 0;\n    top: 0;\n  }\n"], ["\n  :host {\n    --shadow-color: rgba(0, 0, 0, 0.1);\n    --off-white: #f5f5f5;\n    --primary-color: #2d2d2d;\n    --text-color: #ccc;\n  }\n  .lit-progress-bar {\n    width: 100%;\n    height: 20px;\n    background: var(--off-white);\n    border-radius: 2px;\n    position: relative;\n    overflow: hidden;\n    text-align: center;\n    -webkit-box-shadow: inset 0 1px 2px var(--shadow-color);\n    box-shadow: inset 0 1px 2px var(--shadow-color);\n    padding: 2px;\n    margin-bottom: 4px;\n  }\n  .lit-progress-bar__inner {\n    width: 100%;\n    height: 100%;\n    background: var(--primary-color);\n    position: absolute;\n    top: 0;\n    left: -100%;\n    text-align: center;\n    line-height: 35px;\n    font-size: 1em;\n    will-change: transform;\n    transition: transform 100ms ease-in;\n  }\n  .lit-progress-bar__value {\n    color: var(--text-color);\n    z-index: 2;\n    position: absolute;\n    text-align: center;\n    left: 0;\n    right: 0;\n    top: 0;\n  }\n"])));
var templateObject_1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var LithiumProgressBar = /** @class */ (function (_super) {
    __extends(LithiumProgressBar, _super);
    function LithiumProgressBar() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.value = 0;
        _this.showValue = true;
        return _this;
    }
    Object.defineProperty(LithiumProgressBar, "styles", {
        get: /**
         * @return {?}
         */
        function () {
            return styles;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumProgressBar.prototype.render = /**
     * @return {?}
     */
    function () {
        return html(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      <div class=\"lit-progress-bar\">\n        <div style=\"transform: translateX(", "%)\"\n          class=\"lit-progress-bar__inner\" role=\"progressbar\" aria-valuenow=\"", "\" aria-valuemin=\"0\" aria-valuemax=\"100\"></div>\n        ", "\n      </div>\n    "], ["\n      <div class=\"lit-progress-bar\">\n        <div style=\"transform: translateX(", "%)\"\n          class=\"lit-progress-bar__inner\" role=\"progressbar\" aria-valuenow=\"", "\" aria-valuemin=\"0\" aria-valuemax=\"100\"></div>\n        ", "\n      </div>\n    "])), this.value, this.value, this.showValue ? html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["<div class=\"lit-progress-bar__value\">", "%</div>"], ["<div class=\"lit-progress-bar__value\">", "%</div>"])), this.value) : '');
    };
    __decorate([
        property({ type: Number }),
        __metadata("design:type", Object)
    ], LithiumProgressBar.prototype, "value", void 0);
    __decorate([
        property({ type: Boolean }),
        __metadata("design:type", Object)
    ], LithiumProgressBar.prototype, "showValue", void 0);
    return LithiumProgressBar;
}(LitElement));
registerElementSafely('li-progress-bar', LithiumProgressBar);
var templateObject_1$1, templateObject_2;

export { LithiumProgressBar };
//# sourceMappingURL=lithiumjs-progress-bar.js.map
