import { __makeTemplateObject, __extends, __decorate, __metadata } from 'tslib';
import { css, html, property, LitElement } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  :host {\n    --border-color: #ccc;\n    --padding: 8px;\n  }\n\n  .li-tab__content {\n    padding: var(--padding);\n    overflow: visible;\n    min-height: 225px;\n    border-top: 1px solid var(--border-color);\n  }\n\n  @media (min-width: 480px) {\n    .li-tab__content {\n      padding: 18px;\n    }\n  }\n"], ["\n  :host {\n    --border-color: #ccc;\n    --padding: 8px;\n  }\n\n  .li-tab__content {\n    padding: var(--padding);\n    overflow: visible;\n    min-height: 225px;\n    border-top: 1px solid var(--border-color);\n  }\n\n  @media (min-width: 480px) {\n    .li-tab__content {\n      padding: 18px;\n    }\n  }\n"])));
var templateObject_1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var LithiumTab = /** @class */ (function (_super) {
    __extends(LithiumTab, _super);
    function LithiumTab() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.title = '';
        return _this;
    }
    Object.defineProperty(LithiumTab, "styles", {
        get: /**
         * @return {?}
         */
        function () { return styles; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumTab.prototype.render = /**
     * @return {?}
     */
    function () {
        return html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n      <div class=\"li-tab__content\">\n        <slot></slot>\n      </div>\n    "], ["\n      <div class=\"li-tab__content\">\n        <slot></slot>\n      </div>\n    "])));
    };
    __decorate([
        property({ type: String }),
        __metadata("design:type", Object)
    ], LithiumTab.prototype, "title", void 0);
    return LithiumTab;
}(LitElement));
var templateObject_1$1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles$1 = css(templateObject_1$2 || (templateObject_1$2 = __makeTemplateObject(["\n  :host {\n    --color-primary: #2d2d2d;\n    --border-color: #ccc;\n    --tab-background-color: #fff;\n    --breakpoint: 480px;\n  }\n\n  .li-tabs {\n    display: block;\n  }\n\n  .li-tabs__nav {\n    margin-bottom: 0;\n    padding-left: 0;\n    list-style: none;\n  }\n\n  .li-tabs__nav::before, .li-tabs__nav::after {\n    content: ' ';\n    display: table;\n    clear: both;\n  }\n\n  .li-tabs__nav > button {\n    position: relative;\n    display: block;\n    background-color: transparent;\n    width: 50%;\n    float: left;\n    margin-bottom: -1px;\n    cursor: pointer;\n    padding: 10px 6px;\n    line-height: 1.42857143;\n    text-decoration: none;\n    text-align: center;\n    transition: all 0.3s;\n    font-weight: 500;\n    font-size: 14px;\n  }\n\n  .li-tabs__nav > button.active,\n  .li-tabs__nav > button.active:hover,\n  .li-tabs__nav > button.active:focus {\n    cursor: default;\n    color: var(--color-primary);\n  }\n\n  .li-tabs__nav > button:focus,\n  .li-tabs__nav > button:hover {\n    color: var(--color-primary);\n  }\n\n  .li-tabs__nav > button:nth-child(-n + 3) {\n    border-bottom: 1px solid var(--border-color);\n  }\n\n  .li-tabs__nav > button:nth-child(even) {\n    border-right: 1px solid var(--border-color);\n  }\n\n  @media (min-width: 300px) {\n    .li-tabs__nav > button {\n      margin-right: 2px;\n      width: auto;\n      text-align: left;\n      border: 1px solid transparent;\n      border-bottom: 3px solid transparent;\n    }\n\n    .li-tabs__nav > button:nth-child(even) {\n      border-right: 0;\n    }\n\n    .li-tabs__nav > button:nth-child(-n + 3) {\n      border-bottom: 3px solid transparent;\n    }\n\n    .li-tabs__nav > button.active {\n      background-color: var(--tab-background-color);\n      border: 1px solid var(--border-color);\n      border-bottom: 3px solid transparent;\n    }\n  }\n\n  @media (min-width: 480px) {\n    .li-tabs__nav > button {\n      padding: 10px 15px;\n    }\n  }\n"], ["\n  :host {\n    --color-primary: #2d2d2d;\n    --border-color: #ccc;\n    --tab-background-color: #fff;\n    --breakpoint: 480px;\n  }\n\n  .li-tabs {\n    display: block;\n  }\n\n  .li-tabs__nav {\n    margin-bottom: 0;\n    padding-left: 0;\n    list-style: none;\n  }\n\n  .li-tabs__nav::before, .li-tabs__nav::after {\n    content: ' ';\n    display: table;\n    clear: both;\n  }\n\n  .li-tabs__nav > button {\n    position: relative;\n    display: block;\n    background-color: transparent;\n    width: 50%;\n    float: left;\n    margin-bottom: -1px;\n    cursor: pointer;\n    padding: 10px 6px;\n    line-height: 1.42857143;\n    text-decoration: none;\n    text-align: center;\n    transition: all 0.3s;\n    font-weight: 500;\n    font-size: 14px;\n  }\n\n  .li-tabs__nav > button.active,\n  .li-tabs__nav > button.active:hover,\n  .li-tabs__nav > button.active:focus {\n    cursor: default;\n    color: var(--color-primary);\n  }\n\n  .li-tabs__nav > button:focus,\n  .li-tabs__nav > button:hover {\n    color: var(--color-primary);\n  }\n\n  .li-tabs__nav > button:nth-child(-n + 3) {\n    border-bottom: 1px solid var(--border-color);\n  }\n\n  .li-tabs__nav > button:nth-child(even) {\n    border-right: 1px solid var(--border-color);\n  }\n\n  @media (min-width: 300px) {\n    .li-tabs__nav > button {\n      margin-right: 2px;\n      width: auto;\n      text-align: left;\n      border: 1px solid transparent;\n      border-bottom: 3px solid transparent;\n    }\n\n    .li-tabs__nav > button:nth-child(even) {\n      border-right: 0;\n    }\n\n    .li-tabs__nav > button:nth-child(-n + 3) {\n      border-bottom: 3px solid transparent;\n    }\n\n    .li-tabs__nav > button.active {\n      background-color: var(--tab-background-color);\n      border: 1px solid var(--border-color);\n      border-bottom: 3px solid transparent;\n    }\n  }\n\n  @media (min-width: 480px) {\n    .li-tabs__nav > button {\n      padding: 10px 15px;\n    }\n  }\n"])));
var templateObject_1$2;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var LithiumTabs = /** @class */ (function (_super) {
    __extends(LithiumTabs, _super);
    function LithiumTabs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.tabs = [];
        _this.index = 0;
        return _this;
    }
    Object.defineProperty(LithiumTabs, "styles", {
        get: /**
         * @return {?}
         */
        function () { return styles$1; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumTabs.prototype.render = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return html(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      <div class=\"li-tabs\">\n        <div class=\"li-tabs__nav\">\n          ", "\n        </div>\n        <slot></slot>\n      </div>\n    "], ["\n      <div class=\"li-tabs\">\n        <div class=\"li-tabs__nav\">\n          ",
            "\n        </div>\n        <slot></slot>\n      </div>\n    "])), this.tabs.map((/**
         * @param {?} t
         * @param {?} i
         * @return {?}
         */
        function (t, i) { return html(templateObject_1$3 || (templateObject_1$3 = __makeTemplateObject(["\n            <button className=", " @click=", ">", "</button>\n          "], ["\n            <button className=", " @click=", ">", "</button>\n          "])), _this.index === i ? 'active' : '', (/**
         * @return {?}
         */
        function () { return _this.tabClick(i); }), t.title); })));
    };
    /**
     * @return {?}
     */
    LithiumTabs.prototype.connectedCallback = /**
     * @return {?}
     */
    function () {
        _super.prototype.connectedCallback.call(this);
        this.tabs = [].slice.call(this.querySelectorAll('li-tab'));
        this.tabClick(0);
    };
    /**
     * @private
     * @param {?} index
     * @return {?}
     */
    LithiumTabs.prototype.tabClick = /**
     * @private
     * @param {?} index
     * @return {?}
     */
    function (index) {
        this.index = index;
        this.showTab();
    };
    /**
     * @private
     * @return {?}
     */
    LithiumTabs.prototype.showTab = /**
     * @private
     * @return {?}
     */
    function () {
        this.tabs.forEach((/**
         * @param {?} t
         * @return {?}
         */
        function (t) { return t.style.display = 'none'; }));
        this.tabs[this.index].style.display = 'block';
    };
    __decorate([
        property(),
        __metadata("design:type", Array)
    ], LithiumTabs.prototype, "tabs", void 0);
    return LithiumTabs;
}(LitElement));
registerElementSafely('li-tab', LithiumTab);
registerElementSafely('li-tabs', LithiumTabs);
var templateObject_1$3, templateObject_2;

export { LithiumTabs };
//# sourceMappingURL=lithiumjs-tabs.js.map
