(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('lit-element'), require('lithiumjs/common')) :
    typeof define === 'function' && define.amd ? define('lithiumjs/nav-bar', ['exports', 'lit-element', 'lithiumjs/common'], factory) :
    (global = global || self, factory((global.lithiumjs = global.lithiumjs || {}, global.lithiumjs['nav-bar'] = {}), global.litElement, global.lithiumjs.common));
}(this, function (exports, litElement, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var styles = litElement.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  :host {\n    --li-header-background-color: #f3f3f3;\n    box-sizing: border-box;\n    margin-bottom: 12px;\n    background-color: var(--li-header-background-color);\n    display: flex;\n    width: 100%;\n    overflow: hidden;\n  }\n\n  :host([sticky]) {\n    position: fixed;\n    z-index: 100;\n  }\n\n  ::slotted(a), ::slotted(button) {\n    display: flex;\n    align-items: center;\n    height: 100%;\n    padding: 12px;\n  }\n\n  ::slotted([li-nav-bar-right]) {\n    margin-left: auto;\n  }\n"], ["\n  :host {\n    --li-header-background-color: #f3f3f3;\n    box-sizing: border-box;\n    margin-bottom: 12px;\n    background-color: var(--li-header-background-color);\n    display: flex;\n    width: 100%;\n    overflow: hidden;\n  }\n\n  :host([sticky]) {\n    position: fixed;\n    z-index: 100;\n  }\n\n  ::slotted(a), ::slotted(button) {\n    display: flex;\n    align-items: center;\n    height: 100%;\n    padding: 12px;\n  }\n\n  ::slotted([li-nav-bar-right]) {\n    margin-left: auto;\n  }\n"])));
    var templateObject_1;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var   
    // @dynamic
    LithiumNavBar = /** @class */ (function (_super) {
        __extends(LithiumNavBar, _super);
        function LithiumNavBar() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(LithiumNavBar, "styles", {
            get: /**
             * @return {?}
             */
            function () { return styles; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        LithiumNavBar.prototype.render = /**
         * @return {?}
         */
        function () {
            return litElement.html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n      <slot></slot>\n    "], ["\n      <slot></slot>\n    "])));
        };
        return LithiumNavBar;
    }(litElement.LitElement));
    common.registerElementSafely('li-nav-bar', LithiumNavBar);
    var templateObject_1$1;

    exports.LithiumNavBar = LithiumNavBar;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lithiumjs-nav-bar.umd.js.map
