(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('lit-element'), require('lithiumjs/common')) :
    typeof define === 'function' && define.amd ? define('lithiumjs/progress-bar', ['exports', 'lit-element', 'lithiumjs/common'], factory) :
    (global = global || self, factory((global.lithiumjs = global.lithiumjs || {}, global.lithiumjs['progress-bar'] = {}), global.litElement, global.lithiumjs.common));
}(this, function (exports, litElement, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var styles = litElement.css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  :host {\n    --shadow-color: rgba(0, 0, 0, 0.1);\n    --off-white: #f5f5f5;\n    --primary-color: #2d2d2d;\n    --text-color: #ccc;\n  }\n  .lit-progress-bar {\n    width: 100%;\n    height: 20px;\n    background: var(--off-white);\n    border-radius: 2px;\n    position: relative;\n    overflow: hidden;\n    text-align: center;\n    -webkit-box-shadow: inset 0 1px 2px var(--shadow-color);\n    box-shadow: inset 0 1px 2px var(--shadow-color);\n    padding: 2px;\n    margin-bottom: 4px;\n  }\n  .lit-progress-bar__inner {\n    width: 100%;\n    height: 100%;\n    background: var(--primary-color);\n    position: absolute;\n    top: 0;\n    left: -100%;\n    text-align: center;\n    line-height: 35px;\n    font-size: 1em;\n    will-change: transform;\n    transition: transform 100ms ease-in;\n  }\n  .lit-progress-bar__value {\n    color: var(--text-color);\n    z-index: 2;\n    position: absolute;\n    text-align: center;\n    left: 0;\n    right: 0;\n    top: 0;\n  }\n"], ["\n  :host {\n    --shadow-color: rgba(0, 0, 0, 0.1);\n    --off-white: #f5f5f5;\n    --primary-color: #2d2d2d;\n    --text-color: #ccc;\n  }\n  .lit-progress-bar {\n    width: 100%;\n    height: 20px;\n    background: var(--off-white);\n    border-radius: 2px;\n    position: relative;\n    overflow: hidden;\n    text-align: center;\n    -webkit-box-shadow: inset 0 1px 2px var(--shadow-color);\n    box-shadow: inset 0 1px 2px var(--shadow-color);\n    padding: 2px;\n    margin-bottom: 4px;\n  }\n  .lit-progress-bar__inner {\n    width: 100%;\n    height: 100%;\n    background: var(--primary-color);\n    position: absolute;\n    top: 0;\n    left: -100%;\n    text-align: center;\n    line-height: 35px;\n    font-size: 1em;\n    will-change: transform;\n    transition: transform 100ms ease-in;\n  }\n  .lit-progress-bar__value {\n    color: var(--text-color);\n    z-index: 2;\n    position: absolute;\n    text-align: center;\n    left: 0;\n    right: 0;\n    top: 0;\n  }\n"])));
    var templateObject_1;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var LithiumProgressBar = /** @class */ (function (_super) {
        __extends(LithiumProgressBar, _super);
        function LithiumProgressBar() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.value = 0;
            _this.showValue = true;
            return _this;
        }
        Object.defineProperty(LithiumProgressBar, "styles", {
            get: /**
             * @return {?}
             */
            function () {
                return styles;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        LithiumProgressBar.prototype.render = /**
         * @return {?}
         */
        function () {
            return litElement.html(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      <div class=\"lit-progress-bar\">\n        <div style=\"transform: translateX(", "%)\"\n          class=\"lit-progress-bar__inner\" role=\"progressbar\" aria-valuenow=\"", "\" aria-valuemin=\"0\" aria-valuemax=\"100\"></div>\n        ", "\n      </div>\n    "], ["\n      <div class=\"lit-progress-bar\">\n        <div style=\"transform: translateX(", "%)\"\n          class=\"lit-progress-bar__inner\" role=\"progressbar\" aria-valuenow=\"", "\" aria-valuemin=\"0\" aria-valuemax=\"100\"></div>\n        ", "\n      </div>\n    "])), this.value, this.value, this.showValue ? litElement.html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["<div class=\"lit-progress-bar__value\">", "%</div>"], ["<div class=\"lit-progress-bar__value\">", "%</div>"])), this.value) : '');
        };
        __decorate([
            litElement.property({ type: Number }),
            __metadata("design:type", Object)
        ], LithiumProgressBar.prototype, "value", void 0);
        __decorate([
            litElement.property({ type: Boolean }),
            __metadata("design:type", Object)
        ], LithiumProgressBar.prototype, "showValue", void 0);
        return LithiumProgressBar;
    }(litElement.LitElement));
    common.registerElementSafely('li-progress-bar', LithiumProgressBar);
    var templateObject_1$1, templateObject_2;

    exports.LithiumProgressBar = LithiumProgressBar;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=lithiumjs-progress-bar.umd.js.map
