/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} tagName
 * @param {?} elementClass
 * @return {?}
 */
function registerElementSafely(tagName, elementClass) {
    /** @type {?} */
    var elementExists = !!customElements.get(tagName);
    if (elementExists) {
        console.warn(elementExists + " has already been registered");
    }
    else {
        customElements.define(tagName, elementClass);
    }
}

export { registerElementSafely };
//# sourceMappingURL=lithiumjs-common.js.map
