import { __makeTemplateObject, __extends } from 'tslib';
import { css, html, LitElement } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  :host {\n    --li-header-background-color: #f3f3f3;\n    box-sizing: border-box;\n    margin-bottom: 12px;\n    background-color: var(--li-header-background-color);\n    display: flex;\n    width: 100%;\n    overflow: hidden;\n  }\n\n  :host([sticky]) {\n    position: fixed;\n    z-index: 100;\n  }\n\n  ::slotted(a), ::slotted(button) {\n    display: flex;\n    align-items: center;\n    height: 100%;\n    padding: 12px;\n  }\n\n  ::slotted([li-nav-bar-right]) {\n    margin-left: auto;\n  }\n"], ["\n  :host {\n    --li-header-background-color: #f3f3f3;\n    box-sizing: border-box;\n    margin-bottom: 12px;\n    background-color: var(--li-header-background-color);\n    display: flex;\n    width: 100%;\n    overflow: hidden;\n  }\n\n  :host([sticky]) {\n    position: fixed;\n    z-index: 100;\n  }\n\n  ::slotted(a), ::slotted(button) {\n    display: flex;\n    align-items: center;\n    height: 100%;\n    padding: 12px;\n  }\n\n  ::slotted([li-nav-bar-right]) {\n    margin-left: auto;\n  }\n"])));
var templateObject_1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var  
// @dynamic
LithiumNavBar = /** @class */ (function (_super) {
    __extends(LithiumNavBar, _super);
    function LithiumNavBar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(LithiumNavBar, "styles", {
        get: /**
         * @return {?}
         */
        function () { return styles; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumNavBar.prototype.render = /**
     * @return {?}
     */
    function () {
        return html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n      <slot></slot>\n    "], ["\n      <slot></slot>\n    "])));
    };
    return LithiumNavBar;
}(LitElement));
registerElementSafely('li-nav-bar', LithiumNavBar);
var templateObject_1$1;

export { LithiumNavBar };
//# sourceMappingURL=lithiumjs-nav-bar.js.map
