import { __makeTemplateObject, __extends, __decorate, __metadata } from 'tslib';
import { css, html, property, LitElement } from 'lit-element';
import { registerElementSafely } from 'lithiumjs/common';
import '@a11y/focus-trap';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  .dropdown div {\n    border: 1px solid #ccc;\n    padding: 12px;\n  }\n"], ["\n  .dropdown div {\n    border: 1px solid #ccc;\n    padding: 12px;\n  }\n"])));
var templateObject_1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var XDropdown = /** @class */ (function (_super) {
    __extends(XDropdown, _super);
    function XDropdown() {
        var _this = _super.call(this) || this;
        _this.visible = false;
        _this.title = 'dropdown';
        _this.visible = false;
        _this.title = 'dropdown';
        return _this;
    }
    Object.defineProperty(XDropdown, "styles", {
        get: /**
         * @return {?}
         */
        function () { return styles; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    XDropdown.prototype.render = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return html(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n      <div class=\"dropdown\">\n        <button @click=\"", "\" class=\"btn\">", "</button>\n        ", "\n      </div>\n    "], ["\n      <div class=\"dropdown\">\n        <button @click=\"", "\" class=\"btn\">", "</button>\n        ",
            "\n      </div>\n    "])), (/**
         * @return {?}
         */
        function () { return _this.toggle(); }), this.title, this.visible ? html(templateObject_1$1 || (templateObject_1$1 = __makeTemplateObject(["\n            <div>\n              <slot></slot>\n            </div>"], ["\n            <div>\n              <slot></slot>\n            </div>"]))) : '');
    };
    /**
     * @return {?}
     */
    XDropdown.prototype.toggle = /**
     * @return {?}
     */
    function () {
        this.visible = !this.visible;
        this.dispatchEvent(new CustomEvent('visibleChange', { detail: this.visible }));
    };
    __decorate([
        property(),
        __metadata("design:type", Object)
    ], XDropdown.prototype, "visible", void 0);
    __decorate([
        property(),
        __metadata("design:type", Object)
    ], XDropdown.prototype, "title", void 0);
    return XDropdown;
}(LitElement));
registerElementSafely('x-dropdown', XDropdown);
var templateObject_1$1, templateObject_2;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles$1 = css(templateObject_1$2 || (templateObject_1$2 = __makeTemplateObject(["\n  :host {\n    --li-header-background-color: #f3f3f3;\n    box-sizing: border-box;\n    margin-bottom: 12px;\n    background-color: var(--li-header-background-color);\n    display: flex;\n    width: 100%;\n    overflow: hidden;\n  }\n\n  :host([sticky]) {\n    position: fixed;\n    z-index: 100;\n  }\n\n  ::slotted(a), ::slotted(button) {\n    display: flex;\n    align-items: center;\n    height: 100%;\n    padding: 12px;\n  }\n\n  ::slotted([li-nav-bar-right]) {\n    margin-left: auto;\n  }\n"], ["\n  :host {\n    --li-header-background-color: #f3f3f3;\n    box-sizing: border-box;\n    margin-bottom: 12px;\n    background-color: var(--li-header-background-color);\n    display: flex;\n    width: 100%;\n    overflow: hidden;\n  }\n\n  :host([sticky]) {\n    position: fixed;\n    z-index: 100;\n  }\n\n  ::slotted(a), ::slotted(button) {\n    display: flex;\n    align-items: center;\n    height: 100%;\n    padding: 12px;\n  }\n\n  ::slotted([li-nav-bar-right]) {\n    margin-left: auto;\n  }\n"])));
var templateObject_1$2;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var  
// @dynamic
LithiumNavBar = /** @class */ (function (_super) {
    __extends(LithiumNavBar, _super);
    function LithiumNavBar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(LithiumNavBar, "styles", {
        get: /**
         * @return {?}
         */
        function () { return styles$1; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumNavBar.prototype.render = /**
     * @return {?}
     */
    function () {
        return html(templateObject_1$3 || (templateObject_1$3 = __makeTemplateObject(["\n      <slot></slot>\n    "], ["\n      <slot></slot>\n    "])));
    };
    return LithiumNavBar;
}(LitElement));
registerElementSafely('li-nav-bar', LithiumNavBar);
var templateObject_1$3;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles$2 = css(templateObject_1$4 || (templateObject_1$4 = __makeTemplateObject(["\n  .li-modal-wrapper {\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    z-index: 300;\n  }\n\n  .li-modal {\n    border: 1px solid #ccc;\n    padding: 12px;\n    background-color: #fff;\n    color: #2d2d2d;\n    width: 500px;\n    max-width: 100%;\n    margin: 24px auto;\n    position: relative;\n    z-index: 302;\n  }\n\n  .li-modal-close-btn {\n    position: absolute;\n    text-align: center;\n    width: auto;\n    height: auto;\n    padding: 12px;\n    font-size: 24px;\n    top: 0;\n    right: 0;\n    line-height: 14px;\n    border: 0;\n    background: transparent;\n    cursor: pointer;\n  }\n\n  .li-modal-backdrop {\n    background-color: rgba(0, 0, 0, 0.5);\n    position: fixed;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    z-index: 301;\n  }\n"], ["\n  .li-modal-wrapper {\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    z-index: 300;\n  }\n\n  .li-modal {\n    border: 1px solid #ccc;\n    padding: 12px;\n    background-color: #fff;\n    color: #2d2d2d;\n    width: 500px;\n    max-width: 100%;\n    margin: 24px auto;\n    position: relative;\n    z-index: 302;\n  }\n\n  .li-modal-close-btn {\n    position: absolute;\n    text-align: center;\n    width: auto;\n    height: auto;\n    padding: 12px;\n    font-size: 24px;\n    top: 0;\n    right: 0;\n    line-height: 14px;\n    border: 0;\n    background: transparent;\n    cursor: pointer;\n  }\n\n  .li-modal-backdrop {\n    background-color: rgba(0, 0, 0, 0.5);\n    position: fixed;\n    top: 0;\n    bottom: 0;\n    right: 0;\n    left: 0;\n    z-index: 301;\n  }\n"])));
var templateObject_1$4;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var LithiumModal = /** @class */ (function (_super) {
    __extends(LithiumModal, _super);
    function LithiumModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.open = false;
        _this.backdropClosable = true;
        return _this;
    }
    Object.defineProperty(LithiumModal, "styles", {
        get: /**
         * @return {?}
         */
        function () {
            return styles$2;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumModal.prototype.render = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return html(templateObject_2$1 || (templateObject_2$1 = __makeTemplateObject(["\n      ", "\n    "], ["\n      ",
            "\n    "])), this.open
            ? html(templateObject_1$5 || (templateObject_1$5 = __makeTemplateObject(["\n          <div class=\"li-modal-wrapper\">\n            <div class=\"li-modal\" role=\"dialog\">\n              <focus-trap>\n                <div class=\"li-modal-header\">\n                  <slot name=\"header\"></slot>\n                  <button @click=\"", "\" type=\"button\" aria-label=\"closed\" class=\"li-modal-close-btn\">&times;</button>\n                </div>\n                <div class=\"li-modal-content\">\n                  <slot></slot>\n                </div>\n                <div class=\"li-modal-footer\">\n                  <slot name=\"footer\"></slot>\n                </div>\n              </focus-trap>\n            </div>\n            <div @click=\"", "\" class=\"li-modal-backdrop\"></div>\n          </div>\n          "], ["\n          <div class=\"li-modal-wrapper\">\n            <div class=\"li-modal\" role=\"dialog\">\n              <focus-trap>\n                <div class=\"li-modal-header\">\n                  <slot name=\"header\"></slot>\n                  <button @click=\"", "\" type=\"button\" aria-label=\"closed\" class=\"li-modal-close-btn\">&times;</button>\n                </div>\n                <div class=\"li-modal-content\">\n                  <slot></slot>\n                </div>\n                <div class=\"li-modal-footer\">\n                  <slot name=\"footer\"></slot>\n                </div>\n              </focus-trap>\n            </div>\n            <div @click=\"", "\" class=\"li-modal-backdrop\"></div>\n          </div>\n          "])), (/**
             * @return {?}
             */
            function () { return _this.close(); }), (/**
             * @return {?}
             */
            function () { return _this.backdropClose(); })) : '');
    };
    /**
     * @param {?} changedProperties
     * @return {?}
     */
    LithiumModal.prototype.updated = /**
     * @param {?} changedProperties
     * @return {?}
     */
    function (changedProperties) {
        if (this.open && this.open !== changedProperties.get('open')) ;
    };
    /**
     * @return {?}
     */
    LithiumModal.prototype.close = /**
     * @return {?}
     */
    function () {
        this.open = !this.open;
        this.dispatchEvent(new CustomEvent('openChange', { detail: this.open }));
    };
    /**
     * @return {?}
     */
    LithiumModal.prototype.backdropClose = /**
     * @return {?}
     */
    function () {
        if (this.backdropClosable) {
            this.close();
        }
    };
    __decorate([
        property({ type: Boolean }),
        __metadata("design:type", Object)
    ], LithiumModal.prototype, "open", void 0);
    __decorate([
        property({ type: Boolean }),
        __metadata("design:type", Object)
    ], LithiumModal.prototype, "backdropClosable", void 0);
    return LithiumModal;
}(LitElement));
registerElementSafely('li-modal', LithiumModal);
var templateObject_1$5, templateObject_2$1;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles$3 = css(templateObject_1$6 || (templateObject_1$6 = __makeTemplateObject(["\n  :host {\n    --header-background-color: #f2f2f2;\n    --header-text-color: #2d2d2d;\n    --nav-top: 0;\n    --nav-border-color: #f2f2f2;\n    --nav-background-color: #fff;\n    --nav-text-color: #2d2d2d;\n    --nav-width: 280px;\n    --transition-speed: 250ms;\n  }\n\n  .li-side-nav {\n    position: fixed;\n    left: -400px;\n    top: var(--nav-top);\n    bottom: 0;\n    width: 80%;\n    max-width: var(--nav-width);\n    z-index: 201;\n    background-color: var(--nav-background-color);\n    overflow: hidden;\n    will-change: left;\n    transition: left var(--transition-speed) ease-in;\n  }\n\n  :host([sticky]) .li-side-nav {\n    border-right: 1px solid var(--nav-border-color);\n  }\n\n  .li-side-nav-open .li-side-nav {\n    left: 0;\n  }\n\n  .li-menu-heading {\n    font-size: 18px;\n    position: relative;\n    height: 50px;\n    overflow: hidden;\n    background-color: var(--header-background-color);\n    color: var(--header-text-color);\n  }\n\n  .li-menu-heading-text {\n    float: left;\n    padding: 14px 16px;\n  }\n\n  .li-menu-close-btn {\n    border: 0;\n    margin-bottom: 6px;\n    padding: 10px 20px;\n    height: 50px;\n    display: block;\n    position: absolute;\n    font-size: 1.5em;\n    right: 0;\n    background-color: transparent;\n    cursor: pointer;\n    color: var(--header-text-color);\n  }\n\n  .li-side-nav-slot::slotted(a), .li-side-nav-slot::slotted(button) {\n    display: block;\n    padding: 18px 13px 16px 26px;\n    font-size: 1em;\n    text-decoration: none;\n    color: var(--nav-text-color);\n    position: relative;\n    font-weight: bold;\n    cursor: pointer;\n  }\n\n  .li-side-nav-backdrop {\n    position: fixed;\n    top: 0;\n    left: 0;\n    z-index: 200;\n    width: 100%;\n    height: 100%;\n    background: transparent;\n    pointer-events: none;\n    will-change: background;\n    transition: background var(--transition-speed) ease-in;\n  }\n\n  .li-side-nav-open .li-side-nav-backdrop {\n    pointer-events: auto;\n    background: rgba(0,0,0,.5);\n  }\n"], ["\n  :host {\n    --header-background-color: #f2f2f2;\n    --header-text-color: #2d2d2d;\n    --nav-top: 0;\n    --nav-border-color: #f2f2f2;\n    --nav-background-color: #fff;\n    --nav-text-color: #2d2d2d;\n    --nav-width: 280px;\n    --transition-speed: 250ms;\n  }\n\n  .li-side-nav {\n    position: fixed;\n    left: -400px;\n    top: var(--nav-top);\n    bottom: 0;\n    width: 80%;\n    max-width: var(--nav-width);\n    z-index: 201;\n    background-color: var(--nav-background-color);\n    overflow: hidden;\n    will-change: left;\n    transition: left var(--transition-speed) ease-in;\n  }\n\n  :host([sticky]) .li-side-nav {\n    border-right: 1px solid var(--nav-border-color);\n  }\n\n  .li-side-nav-open .li-side-nav {\n    left: 0;\n  }\n\n  .li-menu-heading {\n    font-size: 18px;\n    position: relative;\n    height: 50px;\n    overflow: hidden;\n    background-color: var(--header-background-color);\n    color: var(--header-text-color);\n  }\n\n  .li-menu-heading-text {\n    float: left;\n    padding: 14px 16px;\n  }\n\n  .li-menu-close-btn {\n    border: 0;\n    margin-bottom: 6px;\n    padding: 10px 20px;\n    height: 50px;\n    display: block;\n    position: absolute;\n    font-size: 1.5em;\n    right: 0;\n    background-color: transparent;\n    cursor: pointer;\n    color: var(--header-text-color);\n  }\n\n  .li-side-nav-slot::slotted(a), .li-side-nav-slot::slotted(button) {\n    display: block;\n    padding: 18px 13px 16px 26px;\n    font-size: 1em;\n    text-decoration: none;\n    color: var(--nav-text-color);\n    position: relative;\n    font-weight: bold;\n    cursor: pointer;\n  }\n\n  .li-side-nav-backdrop {\n    position: fixed;\n    top: 0;\n    left: 0;\n    z-index: 200;\n    width: 100%;\n    height: 100%;\n    background: transparent;\n    pointer-events: none;\n    will-change: background;\n    transition: background var(--transition-speed) ease-in;\n  }\n\n  .li-side-nav-open .li-side-nav-backdrop {\n    pointer-events: auto;\n    background: rgba(0,0,0,.5);\n  }\n"])));
var templateObject_1$6;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var LithiumSideNav = /** @class */ (function (_super) {
    __extends(LithiumSideNav, _super);
    function LithiumSideNav() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.open = false;
        _this.sticky = false;
        _this.closeOnInnerClick = true;
        return _this;
    }
    Object.defineProperty(LithiumSideNav, "styles", {
        get: /**
         * @return {?}
         */
        function () {
            return styles$3;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumSideNav.prototype.render = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return html(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n      <div .classList=", ">\n        <nav class=\"li-side-nav\">\n          ", "\n          <div @click=", ">\n            <slot class=\"li-side-nav-slot\"></slot>\n          </div>\n        </nav>\n        ", "\n      </div>\n    "], ["\n      <div .classList=", ">\n        <nav class=\"li-side-nav\">\n          ",
            "\n          <div @click=", ">\n            <slot class=\"li-side-nav-slot\"></slot>\n          </div>\n        </nav>\n        ", "\n      </div>\n    "])), this.sticky || this.open ? 'li-side-nav-open' : '', !this.sticky ? html(templateObject_1$7 || (templateObject_1$7 = __makeTemplateObject(["\n            <div class=\"li-menu-heading\">\n              <div class=\"li-menu-heading-text\"><slot name=\"heading\">Menu</slot></div>\n              <button aria-label=\"close menu\" @click=", " class=\"li-menu-close-btn\">&times;</button>\n            </div>\n          "], ["\n            <div class=\"li-menu-heading\">\n              <div class=\"li-menu-heading-text\"><slot name=\"heading\">Menu</slot></div>\n              <button aria-label=\"close menu\" @click=", " class=\"li-menu-close-btn\">&times;</button>\n            </div>\n          "])), (/**
         * @param {?} e
         * @return {?}
         */
        function (e) { return _this.close(); })) : '', (/**
         * @return {?}
         */
        function () { return _this.navClose(); }), !this.sticky ? html(templateObject_2$2 || (templateObject_2$2 = __makeTemplateObject(["<div @click=", " class=\"li-side-nav-backdrop\"></div>"], ["<div @click=", " class=\"li-side-nav-backdrop\"></div>"])), (/**
         * @return {?}
         */
        function () { return _this.close(); })) : '');
    };
    /**
     * @return {?}
     */
    LithiumSideNav.prototype.close = /**
     * @return {?}
     */
    function () {
        this.open = false;
        this.dispatchEvent(new CustomEvent('openChange', { detail: this.open }));
    };
    /**
     * @return {?}
     */
    LithiumSideNav.prototype.navClose = /**
     * @return {?}
     */
    function () {
        if (this.closeOnInnerClick && !this.sticky) {
            this.open = false;
            this.dispatchEvent(new CustomEvent('openChange', { detail: this.open }));
        }
    };
    __decorate([
        property({ type: Boolean }),
        __metadata("design:type", Object)
    ], LithiumSideNav.prototype, "open", void 0);
    __decorate([
        property({ type: Boolean }),
        __metadata("design:type", Object)
    ], LithiumSideNav.prototype, "sticky", void 0);
    __decorate([
        property({ type: Boolean }),
        __metadata("design:type", Object)
    ], LithiumSideNav.prototype, "closeOnInnerClick", void 0);
    return LithiumSideNav;
}(LitElement));
registerElementSafely('li-side-nav', LithiumSideNav);
var templateObject_1$7, templateObject_2$2, templateObject_3;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles$4 = css(templateObject_1$8 || (templateObject_1$8 = __makeTemplateObject(["\n  :host {\n    --border-color: #ccc;\n    --padding: 8px;\n  }\n\n  .li-tab__content {\n    padding: var(--padding);\n    overflow: visible;\n    min-height: 225px;\n    border-top: 1px solid var(--border-color);\n  }\n\n  @media (min-width: 480px) {\n    .li-tab__content {\n      padding: 18px;\n    }\n  }\n"], ["\n  :host {\n    --border-color: #ccc;\n    --padding: 8px;\n  }\n\n  .li-tab__content {\n    padding: var(--padding);\n    overflow: visible;\n    min-height: 225px;\n    border-top: 1px solid var(--border-color);\n  }\n\n  @media (min-width: 480px) {\n    .li-tab__content {\n      padding: 18px;\n    }\n  }\n"])));
var templateObject_1$8;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var LithiumTab = /** @class */ (function (_super) {
    __extends(LithiumTab, _super);
    function LithiumTab() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.title = '';
        return _this;
    }
    Object.defineProperty(LithiumTab, "styles", {
        get: /**
         * @return {?}
         */
        function () { return styles$4; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumTab.prototype.render = /**
     * @return {?}
     */
    function () {
        return html(templateObject_1$9 || (templateObject_1$9 = __makeTemplateObject(["\n      <div class=\"li-tab__content\">\n        <slot></slot>\n      </div>\n    "], ["\n      <div class=\"li-tab__content\">\n        <slot></slot>\n      </div>\n    "])));
    };
    __decorate([
        property({ type: String }),
        __metadata("design:type", Object)
    ], LithiumTab.prototype, "title", void 0);
    return LithiumTab;
}(LitElement));
var templateObject_1$9;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var styles$5 = css(templateObject_1$a || (templateObject_1$a = __makeTemplateObject(["\n  :host {\n    --color-primary: #2d2d2d;\n    --border-color: #ccc;\n    --tab-background-color: #fff;\n    --breakpoint: 480px;\n  }\n\n  .li-tabs {\n    display: block;\n  }\n\n  .li-tabs__nav {\n    margin-bottom: 0;\n    padding-left: 0;\n    list-style: none;\n  }\n\n  .li-tabs__nav::before, .li-tabs__nav::after {\n    content: ' ';\n    display: table;\n    clear: both;\n  }\n\n  .li-tabs__nav > button {\n    position: relative;\n    display: block;\n    background-color: transparent;\n    width: 50%;\n    float: left;\n    margin-bottom: -1px;\n    cursor: pointer;\n    padding: 10px 6px;\n    line-height: 1.42857143;\n    text-decoration: none;\n    text-align: center;\n    transition: all 0.3s;\n    font-weight: 500;\n    font-size: 14px;\n  }\n\n  .li-tabs__nav > button.active,\n  .li-tabs__nav > button.active:hover,\n  .li-tabs__nav > button.active:focus {\n    cursor: default;\n    color: var(--color-primary);\n  }\n\n  .li-tabs__nav > button:focus,\n  .li-tabs__nav > button:hover {\n    color: var(--color-primary);\n  }\n\n  .li-tabs__nav > button:nth-child(-n + 3) {\n    border-bottom: 1px solid var(--border-color);\n  }\n\n  .li-tabs__nav > button:nth-child(even) {\n    border-right: 1px solid var(--border-color);\n  }\n\n  @media (min-width: 300px) {\n    .li-tabs__nav > button {\n      margin-right: 2px;\n      width: auto;\n      text-align: left;\n      border: 1px solid transparent;\n      border-bottom: 3px solid transparent;\n    }\n\n    .li-tabs__nav > button:nth-child(even) {\n      border-right: 0;\n    }\n\n    .li-tabs__nav > button:nth-child(-n + 3) {\n      border-bottom: 3px solid transparent;\n    }\n\n    .li-tabs__nav > button.active {\n      background-color: var(--tab-background-color);\n      border: 1px solid var(--border-color);\n      border-bottom: 3px solid transparent;\n    }\n  }\n\n  @media (min-width: 480px) {\n    .li-tabs__nav > button {\n      padding: 10px 15px;\n    }\n  }\n"], ["\n  :host {\n    --color-primary: #2d2d2d;\n    --border-color: #ccc;\n    --tab-background-color: #fff;\n    --breakpoint: 480px;\n  }\n\n  .li-tabs {\n    display: block;\n  }\n\n  .li-tabs__nav {\n    margin-bottom: 0;\n    padding-left: 0;\n    list-style: none;\n  }\n\n  .li-tabs__nav::before, .li-tabs__nav::after {\n    content: ' ';\n    display: table;\n    clear: both;\n  }\n\n  .li-tabs__nav > button {\n    position: relative;\n    display: block;\n    background-color: transparent;\n    width: 50%;\n    float: left;\n    margin-bottom: -1px;\n    cursor: pointer;\n    padding: 10px 6px;\n    line-height: 1.42857143;\n    text-decoration: none;\n    text-align: center;\n    transition: all 0.3s;\n    font-weight: 500;\n    font-size: 14px;\n  }\n\n  .li-tabs__nav > button.active,\n  .li-tabs__nav > button.active:hover,\n  .li-tabs__nav > button.active:focus {\n    cursor: default;\n    color: var(--color-primary);\n  }\n\n  .li-tabs__nav > button:focus,\n  .li-tabs__nav > button:hover {\n    color: var(--color-primary);\n  }\n\n  .li-tabs__nav > button:nth-child(-n + 3) {\n    border-bottom: 1px solid var(--border-color);\n  }\n\n  .li-tabs__nav > button:nth-child(even) {\n    border-right: 1px solid var(--border-color);\n  }\n\n  @media (min-width: 300px) {\n    .li-tabs__nav > button {\n      margin-right: 2px;\n      width: auto;\n      text-align: left;\n      border: 1px solid transparent;\n      border-bottom: 3px solid transparent;\n    }\n\n    .li-tabs__nav > button:nth-child(even) {\n      border-right: 0;\n    }\n\n    .li-tabs__nav > button:nth-child(-n + 3) {\n      border-bottom: 3px solid transparent;\n    }\n\n    .li-tabs__nav > button.active {\n      background-color: var(--tab-background-color);\n      border: 1px solid var(--border-color);\n      border-bottom: 3px solid transparent;\n    }\n  }\n\n  @media (min-width: 480px) {\n    .li-tabs__nav > button {\n      padding: 10px 15px;\n    }\n  }\n"])));
var templateObject_1$a;

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var LithiumTabs = /** @class */ (function (_super) {
    __extends(LithiumTabs, _super);
    function LithiumTabs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.tabs = [];
        _this.index = 0;
        return _this;
    }
    Object.defineProperty(LithiumTabs, "styles", {
        get: /**
         * @return {?}
         */
        function () { return styles$5; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    LithiumTabs.prototype.render = /**
     * @return {?}
     */
    function () {
        var _this = this;
        return html(templateObject_2$3 || (templateObject_2$3 = __makeTemplateObject(["\n      <div class=\"li-tabs\">\n        <div class=\"li-tabs__nav\">\n          ", "\n        </div>\n        <slot></slot>\n      </div>\n    "], ["\n      <div class=\"li-tabs\">\n        <div class=\"li-tabs__nav\">\n          ",
            "\n        </div>\n        <slot></slot>\n      </div>\n    "])), this.tabs.map((/**
         * @param {?} t
         * @param {?} i
         * @return {?}
         */
        function (t, i) { return html(templateObject_1$b || (templateObject_1$b = __makeTemplateObject(["\n            <button className=", " @click=", ">", "</button>\n          "], ["\n            <button className=", " @click=", ">", "</button>\n          "])), _this.index === i ? 'active' : '', (/**
         * @return {?}
         */
        function () { return _this.tabClick(i); }), t.title); })));
    };
    /**
     * @return {?}
     */
    LithiumTabs.prototype.connectedCallback = /**
     * @return {?}
     */
    function () {
        _super.prototype.connectedCallback.call(this);
        this.tabs = [].slice.call(this.querySelectorAll('li-tab'));
        this.tabClick(0);
    };
    /**
     * @private
     * @param {?} index
     * @return {?}
     */
    LithiumTabs.prototype.tabClick = /**
     * @private
     * @param {?} index
     * @return {?}
     */
    function (index) {
        this.index = index;
        this.showTab();
    };
    /**
     * @private
     * @return {?}
     */
    LithiumTabs.prototype.showTab = /**
     * @private
     * @return {?}
     */
    function () {
        this.tabs.forEach((/**
         * @param {?} t
         * @return {?}
         */
        function (t) { return t.style.display = 'none'; }));
        this.tabs[this.index].style.display = 'block';
    };
    __decorate([
        property(),
        __metadata("design:type", Array)
    ], LithiumTabs.prototype, "tabs", void 0);
    return LithiumTabs;
}(LitElement));
registerElementSafely('li-tab', LithiumTab);
registerElementSafely('li-tabs', LithiumTabs);
var templateObject_1$b, templateObject_2$3;

export { LithiumModal, LithiumNavBar, LithiumSideNav, LithiumTabs, XDropdown };
//# sourceMappingURL=lithiumjs.js.map
